const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const coupon_redemptions = sequelize.define(
    'coupon_redemptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

redeemed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  coupon_redemptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.coupon_redemptions.belongsTo(db.coupons, {
      as: 'coupon',
      foreignKey: {
        name: 'couponId',
      },
      constraints: false,
    });

    db.coupon_redemptions.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });

    db.coupon_redemptions.belongsTo(db.users, {
      as: 'customer',
      foreignKey: {
        name: 'customerId',
      },
      constraints: false,
    });




    db.coupon_redemptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.coupon_redemptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return coupon_redemptions;
};


